/*
-=:> By Daniel Augusto Nunes, daniel@microuniverso.com.br

-=:> CONJUNTO DE ROTINAS QUE EFETUAM UMA BUSCA NUM FRAME INVISVEL.
	Para que a busca seja realizada  necessrio especificar o frame oculto a ser utilizado como 
plano de fundo para a pesquisa, a pgina motor da pesquisa e os parmetros necessrios para que 
essa pgina realize a busca: Um campo descritivo [para retorno da descrio do objeto], um campo 
hidden [para receber o ID do objeto, caso encontrado], e parmetros adicionais, criados para dar
uma maior flexibilidade, pois o nmero de parmetros pode crescer  vontade.

Exemplo de utilizao:

	<input name="DESC_EMPRESA" type="text" value="<%=Request.Form("DESC_EMPRESA")%>" size=45 OnKeyUp="SetaParam('selecao/pesqempresa.asp', document.forms[0], 'ID_EMPRESA', 'DESC_EMPRESA', 'frame_no=2&nm_empresa='+document.forms[0].DESC_EMPRESA.value); Type(2);" OnBlur="PesquisaFull();">
	<input name="ID_EMPRESA" type="hidden" value="<%=Request.Form("ID_EMPRESA")%>">
	<a href="javascript:SetaParam('selecao/pesqempresa.asp', document.forms[0], 'ID_EMPRESA', 'DESC_EMPRESA', 'frame_no=2&nm_empresa='+document.forms[0].DESC_EMPRESA.value); PesquisaFull();">
		<img SRC="IMAGES/procurar.jpg" ALIGN="Absmiddle" title="Clique para procurar!" style="BORDER:none;" WIDTH="21" HEIGHT="17">
	</a>
*/

var iTimer = 0;
var pgpesq, form, cpo_hidden, cpo_desc, listapar, flg_vazio;
var parOK = false;

function Type(intervalo){
	
	if (iTimer != 0){
		window.clearTimeout(iTimer);
		iTimer = window.setTimeout("PesquisaFull()", intervalo*1000);
	}
	else
		iTimer = window.setTimeout("PesquisaFull()", intervalo*1000);

	return;
}

function SetaParam(p_pgpesq, p_form, p_cpo_hidden, p_cpo_desc, p_listapar, p_flg_vazio){
	pgpesq = p_pgpesq;
	form = p_form;
	cpo_hidden = p_cpo_hidden;
	cpo_desc = p_cpo_desc;
	listapar = p_listapar;
	flg_vazio = p_flg_vazio;
	parOK = true;
}

function CancelTimer(){
	if (iTimer != 0)
		window.clearTimeout(iTimer);
	return;
}

function PesquisaFull(){
	CancelTimer();
	
	if(!parOK)
		return;
				
	if(flg_vazio)
		parent.frames[1].location.replace(pgpesq+'?cpo_hidden='+cpo_hidden+'&cpo_desc='+cpo_desc+'&'+listapar);
	else{
		if (eval('form.'+cpo_desc+'.value == ""'))
			eval('form.'+cpo_hidden+'.value = ""');
		else
			parent.frames[1].location.replace(pgpesq+'?cpo_hidden='+cpo_hidden+'&cpo_desc='+cpo_desc+'&'+listapar);
		}

	parOK = false;
}

/*
	
*/